Index: /trunk/src/VBox/VMM/VMMR3/CPUM.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR3/CPUM.cpp	(revision 41902)
+++ /trunk/src/VBox/VMM/VMMR3/CPUM.cpp	(revision 41903)
@@ -174,17 +174,17 @@
     SSMFIELD_ENTRY(         CPUMCTX, rcx),
     SSMFIELD_ENTRY(         CPUMCTX, rsp),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, lss_esp),
+    SSMFIELD_ENTRY_OLD(              lss_esp, sizeof(uint32_t)),
     SSMFIELD_ENTRY(         CPUMCTX, ss),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, ssPadding),
+    SSMFIELD_ENTRY_OLD(              ssPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, gs),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, gsPadding),
+    SSMFIELD_ENTRY_OLD(              gsPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, fs),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, fsPadding),
+    SSMFIELD_ENTRY_OLD(              fsPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, es),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, esPadding),
+    SSMFIELD_ENTRY_OLD(              esPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, ds),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, dsPadding),
+    SSMFIELD_ENTRY_OLD(              dsPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, cs),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, csPadding),
+    SSMFIELD_ENTRY_OLD(              csPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, rflags),
     SSMFIELD_ENTRY(         CPUMCTX, rip),
@@ -223,21 +223,21 @@
     SSMFIELD_ENTRY(         CPUMCTX, dr[2]),
     SSMFIELD_ENTRY(         CPUMCTX, dr[3]),
-    SSMFIELD_ENTRY(         CPUMCTX, dr[4]),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, dr[5]),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, dr[6]),
+    SSMFIELD_ENTRY_OLD(              dr[4], sizeof(uint64_t)),
+    SSMFIELD_ENTRY_OLD(              dr[5], sizeof(uint64_t)),
+    SSMFIELD_ENTRY(         CPUMCTX, dr[6]),
     SSMFIELD_ENTRY(         CPUMCTX, dr[7]),
     SSMFIELD_ENTRY(         CPUMCTX, gdtr.cbGdt),
     SSMFIELD_ENTRY(         CPUMCTX, gdtr.pGdt),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, gdtrPadding),
+    SSMFIELD_ENTRY_OLD(              gdtrPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, idtr.cbIdt),
     SSMFIELD_ENTRY(         CPUMCTX, idtr.pIdt),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, idtrPadding),
+    SSMFIELD_ENTRY_OLD(              idtrPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, ldtr),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, ldtrPadding),
+    SSMFIELD_ENTRY_OLD(              ldtrPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(         CPUMCTX, tr),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, trPadding),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, SysEnter.cs),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, SysEnter.eip),
-    SSMFIELD_ENTRY_IGNORE(  CPUMCTX, SysEnter.esp),
+    SSMFIELD_ENTRY(         CPUMCTX, trPadding),
+    SSMFIELD_ENTRY(         CPUMCTX, SysEnter.cs),
+    SSMFIELD_ENTRY(         CPUMCTX, SysEnter.eip),
+    SSMFIELD_ENTRY(         CPUMCTX, SysEnter.esp),
     SSMFIELD_ENTRY(         CPUMCTX, msrEFER),
     SSMFIELD_ENTRY(         CPUMCTX, msrSTAR),
@@ -305,16 +305,16 @@
     SSMFIELD_ENTRY_U32_ZX_U64(  CPUMCTX, rsp),
     SSMFIELD_ENTRY(             CPUMCTX, ss),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, ssPadding),
+    SSMFIELD_ENTRY_OLD(                  ssPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY_OLD(         CPUMCTX, sizeof(uint64_t) /*rsp_notused*/),
     SSMFIELD_ENTRY(             CPUMCTX, gs),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, gsPadding),
+    SSMFIELD_ENTRY_OLD(                  gsPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(             CPUMCTX, fs),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, fsPadding),
+    SSMFIELD_ENTRY_OLD(                  fsPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(             CPUMCTX, es),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, esPadding),
+    SSMFIELD_ENTRY_OLD(                  esPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(             CPUMCTX, ds),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, dsPadding),
+    SSMFIELD_ENTRY_OLD(                  dsPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(             CPUMCTX, cs),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, csPadding),
+    SSMFIELD_ENTRY_OLD(                  csPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(             CPUMCTX, rflags),
     SSMFIELD_ENTRY(             CPUMCTX, rip),
@@ -354,23 +354,23 @@
     SSMFIELD_ENTRY(             CPUMCTX, dr[2]),
     SSMFIELD_ENTRY(             CPUMCTX, dr[3]),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, dr[4]),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, dr[5]),
+    SSMFIELD_ENTRY_OLD(                  dr[4], sizeof(uint64_t)),
+    SSMFIELD_ENTRY_OLD(                  dr[5], sizeof(uint64_t)),
     SSMFIELD_ENTRY(             CPUMCTX, dr[6]),
     SSMFIELD_ENTRY(             CPUMCTX, dr[7]),
     SSMFIELD_ENTRY(             CPUMCTX, gdtr.cbGdt),
     SSMFIELD_ENTRY_U32_ZX_U64(  CPUMCTX, gdtr.pGdt),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, gdtrPadding),
+    SSMFIELD_ENTRY_OLD(                  gdtrPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY_OLD(                  gdtrPadding64, sizeof(uint64_t)),
     SSMFIELD_ENTRY(             CPUMCTX, idtr.cbIdt),
     SSMFIELD_ENTRY_U32_ZX_U64(  CPUMCTX, idtr.pIdt),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, idtrPadding),
+    SSMFIELD_ENTRY_OLD(                  idtrPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY_OLD(                  idtrPadding64, sizeof(uint64_t)),
     SSMFIELD_ENTRY(             CPUMCTX, ldtr),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, ldtrPadding),
+    SSMFIELD_ENTRY_OLD(                  ldtrPadding, sizeof(uint16_t)),
     SSMFIELD_ENTRY(             CPUMCTX, tr),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, trPadding),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, SysEnter.cs),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, SysEnter.eip),
-    SSMFIELD_ENTRY_IGNORE(      CPUMCTX, SysEnter.esp),
+    SSMFIELD_ENTRY_OLD(                  trPadding, sizeof(uint16_t)),
+    SSMFIELD_ENTRY(             CPUMCTX, SysEnter.cs),
+    SSMFIELD_ENTRY(             CPUMCTX, SysEnter.eip),
+    SSMFIELD_ENTRY(             CPUMCTX, SysEnter.esp),
     SSMFIELD_ENTRY(             CPUMCTX, msrEFER),
     SSMFIELD_ENTRY(             CPUMCTX, msrSTAR),